// 
// File:   Complesso.h
// Author: root
//
// Created on 31 gennaio 2008, 8.44
//

#ifndef _COMPLESSO_H
#define	_COMPLESSO_H

#include <ostream>
#include <vector>

using namespace std;

class Complesso{
	float *re;
	float *im;
public:
	// Costruttore senza parametri
	Complesso();
	// Costruttore con due parametri
	Complesso(float re, float im);
	// Costruttore con un parametro (parte immaginaria sarà inizializzata a zero
	Complesso(float re);
	// Distruttore
	~Complesso();
	// Costruttore di copia
	Complesso(const Complesso &x);
	// Operatore di somma
	Complesso operator+(Complesso x);
	// Operatore di assegnazione
	Complesso operator=(Complesso x);
	// Operatore di assegnazione solo per la parte reale
	Complesso operator=(float x);
        // Calcola il modulo
        float modulo();
        // Calcola la fase
        float fase();
        
        void setReale(float r);
        
        void setImmaginario(float i);
        
        friend ostream& operator<<(ostream &o, Complesso c);
        friend istream& operator>>(istream &i, Complesso &c);
        
};

bool operator<(Complesso a, Complesso b);
bool operator==(Complesso a, Complesso b);

ostream& operator<<(ostream &o, Complesso c);
istream& operator<<(istream &i, Complesso &c);

ostream & operator<<(ostream &o, vector<Complesso> &v);
istream & operator>>(istream &o, vector<Complesso> &v);


#endif	/* _COMPLESSO_H */

